import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;


public abstract class AiPlayer extends LocalPlayer implements Runnable {

    List<Thread> shootThreads;

    public AiPlayer() {
        this.setName("AI Player");
        this.shootThreads = new ArrayList<>();
    }
    public Point RandomPoint() {
        Random random = new Random(); // Pseudo Random für zufallszahlen
        int posx = random.nextInt(super.board.getSize()); // Generiert 0 - 13
        int posy = random.nextInt(super.board.getSize()); // 
        return new Point(posx,posy);
    }
    
    @Override
    public void createBoard(int size) {
        super.createBoard(size);
        this.aiSetShips();
        this.ready();
    }

    public void aiSetShips() {
        for(int i = 0; i < super.board.getShips().size(); i++) {  // Interiert durch alle Shiffe
            //TODO: set horizontal
            while(!super.board.getShips().get(i).setPosition(RandomPoint(), true, super.board.getShips(), super.board.getSize())) {}
        }    // Versucht das Aktuelle Shiff zu setzten und wiederholt solange bis es funktioniert
        return;
    }

    public void aiShoot() {
        this.enemy.receiveShoot(RandomPoint());
        return;
    }

    @Override
    public synchronized void receiveHit(HitResponse hitResponse) {
        super.receiveHit(hitResponse);
        if (this.myTurn) {
            Thread t = new Thread(this);
            t.start();
            this.shootThreads.add(t);
        }

    }
    
    @Override
    public synchronized void receiveShoot(Point point) {
        super.receiveShoot(point);
        if (this.myTurn) {
            Thread t = new Thread(this);
            t.start();
            this.shootThreads.add(t);
        }
    }
    
    
    @Override
    public void beginTurn() {
        Thread t = new Thread(this);
        t.start();
        this.shootThreads.add(t);
    }
    
    public void run() {
        Iterator<Thread> i = this.shootThreads.iterator();
        while(i.hasNext()) {
            Thread thread = i.next();
            if (!thread.isAlive()) {
                try {
                    thread.join();
                    i.remove();
                } catch (InterruptedException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
            
        }
        
        try {
            Thread.sleep(300);
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
           
        this.aiShoot();
    }
}